////////////////////////////////////////////////////////
// 3D Würfel mit Textur aus Kapitel Räumliche Strukturen
//////////////////////////////////////////////////////// 
PImage tex;
 
void setup()  { 
  size(800, 800, P3D); 
  noStroke();
  tex = loadImage("wuerfeltextur.jpg");
  textureMode(IMAGE);

} 
 
void draw()  { 
  background(255);
  lights();
  // verschiebe Objekt in Bildmitte
  translate(width/2, height/2, -10); 
  // rotiere um x-Achse je nach Höhe der Maus
  rotateX(- mouseY/float(height) * TWO_PI); 
  // rotiere um y-Achse je nach seitlicher Koordinate der Maus
  rotateY(- mouseX/float(width) * TWO_PI);   
  boxTextured(200,tex);
} 

void boxTextured(float scalef, PImage tex) {
  scale(scalef,scalef,scalef);
  
  beginShape(QUADS);
  texture(tex);
  
  // +Z Richtung, frontale Fläche
  
  vertex(-1, -1,  1, 0, 302); 
  vertex( 1, -1,  1, 300, 302);
  vertex( 1,  1,  1, 300, 602);
  vertex(-1,  1,  1, 0, 602);

  // -Z Richtung, hintere Fläche
  vertex( 1, -1, -1, 600, 302);
  vertex(-1, -1, -1, 900, 302);
  vertex(-1,  1, -1, 900, 602);
  vertex( 1,  1, -1, 600, 602);

  // +Y Richtung, untere Fläche
  vertex(-1,  1,  1, 300, 302);
  vertex( 1,  1,  1, 600, 302);
  vertex( 1,  1, -1, 600, 602);
  vertex(-1,  1, -1, 300, 602);

  // -Y Richtung, obere Fläche
  vertex(-1, -1, -1, 900, 302);
  vertex( 1, -1, -1, 1200, 302);
  vertex( 1, -1,  1, 1200, 602);
  vertex(-1, -1,  1, 900, 602);

  // +X Richtung, rechte Fläche
  vertex( 1, -1,  1, 600, 602);
  vertex( 1, -1, -1, 900, 602);
  vertex( 1,  1, -1, 900, 902);
  vertex( 1,  1,  1, 600, 902);

  // -X Richtung, linke Fläche
  vertex(-1, -1, -1, 600, 2);
  vertex(-1, -1,  1, 900, 2);
  vertex(-1,  1,  1, 900, 302);
  vertex(-1,  1, -1, 600, 302);

  endShape();
}